package de.ivu.elect.presentation.wahlbeteiligung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungConversationSelect;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.presentation.replikation.ReplikationPresentationStatus;
import de.ivu.elect.presentation.wahlbeteiligung.WahlbeteiligungVerlaufAusAuswertungCreateView;

public class WahlbeteiligungAuswertungVerlaufErstellenAction extends AbstractWahlbeteiligungAuswertungAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlbeteiligungAuswertungConversationSelect wahlbeteiligungAuswertungConversationSelect;

  @Inject
  private transient ReplikationPresentationStatus replikationPresentationStatus;

  @Override
  public boolean isDisabledInternal(@Nonnull WahlbeteiligungAuswertung wahlbeteiligungAuswertung) {
    return super.isDisabledInternal(wahlbeteiligungAuswertung) || isSlave();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLBETEILIGUNG_VERLAUF_AUS_AUSWERTUNG_CREATE;
  }

  @Override
  protected String doIt(WahlbeteiligungAuswertung wahlbeteiligungAuswertung) {
    wahlbeteiligungAuswertungConversationSelect.setEntity(wahlbeteiligungAuswertung);
    return WahlbeteiligungVerlaufAusAuswertungCreateView.VIEW_ID;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  public String getLabelKey() {
    return "wahlbeteiligung.verlauf.aus.auswertung.create.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconCreate();
  }

  private boolean isSlave() {
    return replikationPresentationStatus.isSlave();
  }
}
